%define with_gcj %{!?_without_gcj:1}%{?_without_gcj:0}
%define archivever  jdk16-141

Summary:          S/MIME and CMS libraries for Bouncy Castle
Name:             bouncycastle-mail
Version:          1.41
Release:          3%{?dist}
Group:            System Environment/Libraries
License:          MIT
URL:              http://www.bouncycastle.org/
Source0:          http://www.bouncycastle.org/download/bcmail-%{archivever}.tar.gz
BuildRoot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires:         bouncycastle == %{version}
Requires:         jpackage-utils >= 1.5
%if %{with_gcj}
Requires:         java-1.5.0-gcj
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
BuildRequires:    java-gcj-compat-devel
%else
BuildArch:        noarch
%endif
BuildRequires:    bouncycastle == %{version}
BuildRequires:    java-devel >= 1.7
BuildRequires:    javamail
BuildRequires:    jpackage-utils >= 1.5
BuildRequires:    junit4

Provides:         bcmail == %{version}-%{release}

%description
Bouncy Castle consists of a lightweight cryptography API and is 
a provider for the Java Cryptography Extension and the Java 
Cryptography Architecture. This library package offers additional 
classes, in particuar generators/processors for S/MIME and CMS, 
for Bouncy Castle.

%prep
%setup -q -n bcmail-%{archivever}
mkdir src
unzip -qq src.zip -d src/
# Remove provided binaries
find . -type f -name "*.class" -exec rm -f {} \;
find . -type f -name "*.jar" -exec rm -f {} \;

%build
pushd src
  export CLASSPATH=$(build-classpath junit4 bcprov javamail)
  javac -target 1.5 `find . -type f -name "*.java"`
  jarfile="../bcmail-%{version}.jar"
  files="`find . -type f -name "*.class"`"
  test ! -d classes && mf="" \
    || mf="`find classes/ -type f -name "*.mf" 2>/dev/null`"
  test -n "$mf" && jar cvfm $jarfile $mf $files \
    || jar cvf $jarfile $files
popd

%install
rm -rf $RPM_BUILD_ROOT

# install bouncy castle mail
install -dm 755 $RPM_BUILD_ROOT%{_javadir}
install -pm 644 bcmail-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/bcmail-%{version}.jar
pushd $RPM_BUILD_ROOT%{_javadir}
  ln -sf bcmail-%{version}.jar bcmail.jar
popd
%if %{with_gcj}
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed
pushd $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed
  ln -sf ../bcmail-%{version}.jar bcmail-%{version}.jar
popd
  %{_bindir}/aot-compile-rpm
%endif

%post
%if %{with_gcj}
  if [ -x %{_bindir}/rebuild-gcj-db ]; then
    %{_bindir}/rebuild-gcj-db
  fi
%endif

%postun
%if %{with_gcj}
  if [ -x %{_bindir}/rebuild-gcj-db ]; then
    %{_bindir}/rebuild-gcj-db
  fi
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc *.html
%{_javadir}/bcmail.jar
%{_javadir}/bcmail-%{version}.jar
%if %{with_gcj}
  %{_javadir}/gcj-endorsed/bcmail-%{version}.jar
  %{_libdir}/gcj/%{name}
%endif

%changelog
* Mon Oct 6 2008 Orcan Ogetbil <orcanbahri@yahoo.com> - 1.41-3
- Added "Provides: bcmail == %%{version}-%%{release}"
- Added "Requires: bouncycastle == %%{version}"

* Sun Oct  5 2008 Orcan Ogetbil <orcanbahri@yahoo.com> - 1.41-2
- Some minor fixes/improvements in the spec file
- Improved Summary/Description
- License is MIT

* Thu Oct  2 2008 Orcan Ogetbil <orcanbahri@yahoo.com> - 1.41-1
- Initial Release
- Spec file stolen from bouncycastle-1.41-1 and modified for bcmail
